// Rafed Pray Times Gadget!
// Hossein Taghi-Zadeh
// Best thanks to "Hamid Zarrabi-Zadeh" 
// This module based on "Pray Times! firefox add-ons" module
// Licensed under GPL

function Azan() 
{
	// Mr.HTZ Added
	this.sleep = false;

	this.num = 7;

	this.name = new Array('Fajr', 'Sunrise', 'Dhuhr', 'Asr', 'Sunset', 'Maghrib', 'Isha');

	this.title = new Array();
	this.title[0] = new Array('صلاة الفجر', 'طلوع الشمس', 'صلاة الظهر', 'صلاة العصر', 'غروب الشمس', 'صلاة المغرب', 'صلاة العشاء');
	this.title[1] = new Array('فجر', 'طلوع خورشيد', 'ظهر', 'فضيلت عصر', 'غروب خورشید', 'مغرب', 'عشاء');
	this.title[2] = new Array('Fajr', 'Sunrise', 'Dhuhr', 'Asr', 'Sunset', 'Maghrib', 'Isha');

	this.shiaAsr = new Array();
	this.shiaAsr[0] = 'فضيلة العصر';
	this.shiaAsr[1] = 'فضیلت عصر';
	this.shiaAsr[2] = 'Fadhila Asr';

	this.to = new Array();
	this.to[0] = ' ل';
	this.to[1] = ' به ';
	this.to[2] = ' to ';

	this.now = new Array();
	this.now[0] = 'الان: ';
	this.now[1] = 'اينک: ';
	this.now[2] = 'Now: ';

	this.time = new Array(2* this.num);
	this.fullTime = new Array(2* this.num);

	this.nextAzan = 0;
	this.timeLeftHM = '';

	this.azanPeriod = false;

	this.timeoutID = 0;
	this.tooltipTimes = null;
	this.tooltipTimeLeft = null;

	this.dataDate = '';

	this.bodyHeight = 172;
}

//--------------------------- Main Functions ---------------------------

Azan.prototype.getTitle = function(i)
{
	var lng = azanPrefs.getIntPref('language');
	var Result = azan.title[lng][i];
	
	if ((i == 3) && (azanPrefs.getAsrJuristic() == prayTime.Shia))
		Result = azan.shiaAsr[lng];
		
	return Result;	
}

Azan.prototype.getName = function(i)
{
	return azan.name[i];	
}

// main counter function
Azan.prototype.run = function()
{
	if (azan.sleep)
		return;
	
	timeoutID = setTimeout(azan.run, 1000);
	azan.handleEvents();

	var now = new Date();
	var hours = now.getHours();
	var minutes = now.getMinutes();
	var seconds = now.getSeconds();
	var nowMinutes = hours* 60+ minutes;
	var nowPlayingAzan = 0;
	azan.playingPeriod = false;

	var azanFlags = azanPrefs.getStrPref('azanFlags');
	var displayMode = azanPrefs.getIntPref('azanDisplayMode'); 

	for (var i=0; i<2*azan.num; i++)
	{
		var z1 = azanFlags.charAt(i% azan.num);
		if (z1 == 'c')
		{
			minutesLeft = azan.time[i]- nowMinutes; // it's +1 in praytime.info;
			if (minutesLeft <= 0 && minutesLeft > -azanPrefs.getIntPref('playDuration'))
			{
				azan.playingPeriod = true;
				nowPlayingAzan = azan.getName(i);
				nowPlayingAzanTitle = azan.getTitle(i);
			}
			if (minutesLeft == -azanPrefs.getIntPref('playDuration'))
				azan.resetAlertIndicators();

			if (minutesLeft >= 0)
			{
				if (minutesLeft > 0)
					if (azanPrefs.getBoolPref('azanStarted') && !azanPrefs.getBoolPref('azanPlaying'))
						azan.resetAlertIndicators();
				
				azan.nextAzan = i;
				azan.timeLeftHM = azan.timeLeftLongString(minutesLeft); 
				var timeLeft = azan.timeLeftString(minutesLeft- 1, seconds);

				if (azan.playingPeriod)
					azan.setDisplay(azan.now[azanPrefs.getIntPref('language')]+ nowPlayingAzanTitle);
				else if (displayMode == 1 || displayMode == 3 && minutesLeft >= azanPrefs.getIntPref('startCountDown'))
					//azan.setDisplay(azan.getTitle(i% azan.num));
					azan.setDisplay(azan.getTitle(i% azan.num)+ ': '+ azan.fullTime[i]);
				else
					azan.setDisplay(timeLeft+ azan.to[azanPrefs.getIntPref('language')] + azan.getTitle(i% azan.num));
					//azan.setDisplay(timeLeft+ ' to '+ azan.getTitle(i% azan.num));
				
				azan.showPreNotification(minutesLeft, azan.getName(i% azan.num));
				//azan.showNotification(minutesLeft, nowPlayingAzan);
				azan.playAzan(minutesLeft, nowPlayingAzan);
				break;
			}
		}
	}
}

// handling events
Azan.prototype.handleEvents = function()
{
	var event = azanPrefs.getIntPref('currentEvent');

	if (event != 0)
	{
		if (event == azanMisc.StopSound)
			azanMisc.stopSound();

		if (event == azanMisc.ResetData)
			this.dataDate = '';

		azanMisc.resetEvent();
	}

//	if (!azan.dataIsValid())
	//{
	azan.readTimes();
	azan.fillTooltip();	// Mr.HTZ Added
	//}
}

//--------------------------- Alerts and Sound ---------------------------

// show advanced notification
Azan.prototype.showPreNotification = function(minutesLeft, nextAzan)
{
	var preMins = azanPrefs.getIntPref('preNotificationMinutes');
	if (minutesLeft == preMins) 
	{
		if (azanPrefs.getBoolPref('showPreNotification') && !azanPrefs.getBoolPref('preNotificationShowed') && nextAzan != 'Sunrise' && nextAzan != 'Sunset' && nextAzan != 'Asr' && nextAzan != 'Isha')
		{
			azanPrefs.setBoolPref('preNotificationShowed', true);
			azanMisc.playAlert();
		}
	}
	else if (minutesLeft <= preMins- 2 || minutesLeft > preMins+ 2)
		azanPrefs.setBoolPref('preNotificationShowed', false);
}

// play azan
Azan.prototype.playAzan = function(minutesLeft, nowPlayingAzan)
{
	if (minutesLeft == 0)
	{
		if (!azanPrefs.getBoolPref('playSound') && !azanPrefs.getBoolPref('azanStarted') && nowPlayingAzan != 'Sunrise' && nowPlayingAzan != 'Sunset' && nowPlayingAzan != 'Asr' && nowPlayingAzan != 'Isha')
		{
			azanPrefs.setBoolPref('azanStarted', true);
			azanPrefs.setBoolPref('azanPlaying', true);
			azanMisc.playFile(azanPrefs.getStrPref('soundFileName'), azanPrefs.getIntPref('soundVolume'));
		}
	}
}

// reset alert indicators
Azan.prototype.resetAlertIndicators = function()
{
	azanPrefs.setBoolPref('notificationShowed', false);
	azanPrefs.setBoolPref('azanStarted', false);
	azanPrefs.setBoolPref('azanPlaying', false);
}

//--------------------------- Counter ---------------------------

// stop counters
Azan.prototype.stop = function()
{
	clearTimeout(timeoutID);
}

// restart counters
Azan.prototype.restart = function()
{
	azan.stop();
	azan.run();
}

// refresh counters
Azan.prototype.refresh = function()
{
	azan.resetAzanData();
	azan.restart();
}

// force to recompute data
Azan.prototype.resetAzanData = function()
{
	azanMisc.triggerEvent(azanMisc.ResetData);
}

//---------------------- Compute Times -----------------------

// read prayer times
Azan.prototype.readTimes = function() 
{
	if(azanPrefs.getStrPref('location') == '')
		return;

	var now = new Date();

	var lat = azanPrefs.getStrPref('latitude');
	var lng = azanPrefs.getStrPref('longitude'); 
	var timeZone = azanMisc.getCurrentTimeZone(now); 

	azanMisc.loadPrayTimePrefs();
	prayTime.setTimeFormat(prayTime.Float);
	var time = prayTime.getPrayerTimes(now, lat, lng, timeZone);
	for (var i=0; i<azan.num; i++)
	{
		azan.time[i] = Math.floor(time[i]* 60+ 0.5);
		azan.fullTime[i] = (azanPrefs.getIntPref('clockFormat') == 1) ? prayTime.floatToTime12(time[i]) : prayTime.floatToTime24(time[i]);
	}

	var tomorrow = azanMisc.nextDay(now);
	var timeZone = azanMisc.getCurrentTimeZone(tomorrow); 
	time = prayTime.getPrayerTimes(tomorrow, lat, lng, timeZone);
	for (var i=0; i<azan.num; i++)
	{
		var i2 = i+ azan.num;
		azan.time[i2] = Math.floor((time[i]+ 24)* 60);
		azan.fullTime[i2] = (azanPrefs.getIntPref('clockFormat') == 1) ? prayTime.floatToTime12(time[i]) : prayTime.floatToTime24(time[i]);
	}

	var day = now.getDate();
	var month = now.getMonth()+ 1;
	this.dataDate = month+ '/'+ day;

	// for updating week days zekr
	azanMisc.refreshZekr(now);
}

// check if current data is uptodate
 Azan.prototype.dataIsValid = function()
{
	var now = new Date();
	var month = now.getMonth()+ 1;
	var day = now.getDate();

	return (this.dataDate == month+ '/'+ day);
}

//---------------------- Display Functions -----------------------

// display str in the status bar
Azan.prototype.setDisplay = function(str)
{
	var c = 'remain-next-azan';
	var imgSrc = "../images/empty.png";
	if (azan.playingPeriod)
	{
		c = 'now-is-azan';
		if (!azanMisc.Stopped) 
			imgSrc = "../images/stop.png";
	}
	$('azan-display-tooltip').className = c;
	$('azan-display-tooltip').innerText = str;
	
	$('img-stop').src = imgSrc;
}

// generate the timeLeft string
Azan.prototype.timeLeftString = function(minutesLeft, seconds)
{
	var hideSeconds = (!azanPrefs.getBoolPref('removeSecondsIfHours')) && (minutesLeft >= 60);
	if (hideSeconds)
		minutesLeft++;

	hours = Math.floor(minutesLeft/ 60);
	minutes = minutesLeft- hours* 60;
	seconds = 59- seconds; 

	hours = azanMisc.twoDigitsFormat(hours);
	minutes = azanMisc.twoDigitsFormat(minutes);
	seconds = azanMisc.twoDigitsFormat(seconds);

	var timeLeft = minutes+ (hideSeconds? '' : ':'+ seconds);
	timeLeft = (!azanPrefs.getBoolPref('removeLeadingZeroHours') && hours == '00' ? '' : hours+ ':')+ timeLeft;
	return timeLeft;
}

// generate the timeLeftHM string
Azan.prototype.timeLeftLongString = function(minutesLeft)
{
	if (minutesLeft < 0) 
		minutesLeft = 0;
	var hours = Math.floor((minutesLeft)/ 60);
	var minutes = (minutesLeft)- hours* 60;

	var hoursTitle = (hours > 1) ? 'hours' : 'hour';
	var str = (hours == '0') ? '' : hours+ ' '+ hoursTitle+ ' and ';
	
	str = str+ minutes+ ' minute'+ (minutes != 1 ? 's' : '');
	return str;
}

// reset tooltip 
Azan.prototype.resetTooltip = function()
{
	var displayPad = $('azan-display');
	if (!azanPrefs.getBoolPref('showTooltip') || !azanPrefs.getBoolPref('showTooltipTimes') && !azanPrefs.getBoolPref('showTooltipTimeLeft'))
		displayPad.tooltip = '';
	else
		displayPad.tooltip = 'azan-toolbar-tooltip';
}

Azan.prototype.getLangDirection = function()
{
	var result = 'rtl';
	if (azanPrefs.getIntPref('language') == 2) // English
		result = 'ltr';

	return (result);
}

Azan.prototype.getLangAlignment = function(inverse)
{
	var result = (inverse == false ? 'right' : 'left');
	if (azanPrefs.getIntPref('language') == 2) // English
		result = (inverse == false ? 'left' : 'right');

	return (result);
}

// fill in the tooltip 
Azan.prototype.fillTooltip = function()
{
	//var tooltipPanel = $('azan-toolbar-tooltip');
	if (azanPrefs.getStrPref('location') == '')
		return;

	if (azanPrefs.getBoolPref('showTooltip') && azanPrefs.getBoolPref('showTooltipTimes'))
	{
		var azanFlags = azanPrefs.getStrPref('azanFlags');
		var offset = azan.nextAzan >= azan.num ? azan.num : 0;

		var j = 0;
		var hided_height = 0;
		for (var i=offset; i<azan.num+ offset; i++)
		{
			j = (i% azan.num);
			var row = $('row_'+j);
			var prayer = $('prayer_'+j);
			var prayer_name = $('prayer_name_'+j);
			var ico = $('ico_'+j);

			if (azanFlags.charAt(j) == 'u')
			{
				row.style.display = 'none';
				hided_height += 12;
			}
			else
			{
				row.style.display = '';
				prayer_name.innerText = azan.getTitle(j)+ '';
				prayer_name.align = azan.getLangAlignment(false);
				prayer.innerText = azan.fullTime[i]+ '';
				prayer.align = azan.getLangAlignment(true);
			}

			if (i == azan.nextAzan)
			{
				ico.src = '../images/blank.gif';
				row.className = 'tooltip-shade';
			}
			else
			{
				row.className = '';
				ico.src = '../images/empty.png';
			}
		}

		$('tooltip-azan-times').dir = azan.getLangDirection();
		$('tooltip-next-azan').dir = azan.getLangDirection();

		if (azanPrefs.getIntPref('dateKind') == myDate.dkGregorian)
			$('tooltip-azan-times-title').dir = 'ltr';	
		else
			$('tooltip-azan-times-title').dir = 'rtl';	
		$('tooltip-azan-times-title').innerHTML = azan.computeDate(offset);		
		
		document.body.style.height = this.bodyHeight - hided_height;
	}
}

Azan.prototype.computeDate = function(offset)
{
	var date = new Date();
	
	if (offset > 0)
		date = azanMisc.nextDay(date);

	var dayOfWeek = date.getDay();

	if (azanPrefs.getIntPref('dateKind') == myDate.dkHijri)
		date.setDate(date.getDate()+ azanPrefs.getIntPref('HijriAdjust'));

	var y = date.getYear();
	var m = date.getMonth() +1;
	var d = date.getDate();

	var Result = ((offset == 0) ? myDate.getTodayName(0, azanPrefs.getIntPref('dateKind')) : myDate.getTodayName(1, azanPrefs.getIntPref('dateKind')));
	
	Result += ': ' + myDate.getDayName(dayOfWeek, azanPrefs.getIntPref('dateKind'));
	Result += ' <br />&nbsp;&nbsp;'+ myDate.getDate(y, m, d, azanPrefs.getIntPref('dateKind'));
	
	return Result;
}

//----------------------- Handling Azan flags -----------------------

// update azan flags
Azan.prototype.updateShowTimes = function()
{
	azanFlags = '';
	for (var i=0 ; i<azan.num ; i++)
		azanFlags = azanFlags+ ($('show-prayer-'+ i).checked ? 'c' : 'u');
		
	azanPrefs.setStrPref('azanFlags', azanFlags);
}

//---------------------- Extension Init -----------------------

// azan initializer
Azan.prototype.init = function()
{
	azanPrefs.setStrPref('installedVersion', azanPrefs.getStrPref('version'));  

	azan.tooltipTimes = $('tooltipTimes');
	azan.tooltipTimeLeft = $('tooltipTimeLeft');
	
	azan.run();
}

//---------------------- azan Object -----------------------

var azan = new Azan;

function Init()
{
	azan.init();

	System.Gadget.settingsUI = "Settings.htm";
	System.Gadget.onSettingsClosed = SettingsClosed;
//	System.Gadget.visibilityChanged = VisibilityChanged;
}

function SettingsClosed(event)
{
	if (event.closeAction == event.Action.commit)
	{
		azan.readTimes();
		azan.fillTooltip();
	}
}
