﻿// Rafed Pray Times Gadget!
// Hossein Taghi-Zadeh
// Best thanks to "Kambiz R. Khojasteh" 
// This module based on "SolarUtl.pas for Delphi"
// Licensed under GPL

function Integer(val) {	this.value = val; }
function Frac(X) { X = X - Math.floor(X); if (X<0) {X = X + 1.0;} return X; }

//-------------------------- TDate --------------------------------
function TDate()
{
	this.dkSolar = 2;
	this.dkGregorian = 1;
	this.dkHijri = 0;
	
	this.LeapMonth = new Array();
	this.DaysToMonth = new Array();
	this.DaysOfMonths = new Array();
	this.MonthNames = new Array();
	this.DayNames = new Array();
	this.TodayNames = new Array();
	
	this.LeapMonth[this.dkSolar] = 12; /*Esfand*/
	this.LeapMonth[this.dkGregorian] = 2; /*February*/
	this.LeapMonth[this.dkHijri] = 3; /*Rabi1*/

	this.DaysOfMonths[this.dkSolar] = new Array(0, 31, 31,  31,  31,  31,  31,  30,  30,  30,  30,  30,  29);
												// Far, Ord, Kho, Tir, Mor, Sha, Meh, Aba, Aza, Day, Bah,^Esf 
	this.DaysOfMonths[this.dkGregorian] = new Array(0, 31, 28,  31,  30,  31,  30,  31,  31,  30,  31,  30,  31);
													// Jan,^Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec 
	this.DaysOfMonths[this.dkHijri] = new Array(0, 30, 29,  30,  29,  30,  29,  30,  29,  30,  29,  30, 30);
												// Moh, Saf,^Ra1, Ra2, Ja1, Ja2, Raj, Sha, Ram, Shv, Zig, Zih 
	
	this.DaysToMonth[this.dkSolar] = new Array(0, 0, 31, 62, 93, 124, 155, 186, 216, 246, 276, 306, 336, 365);
												// Far, Ord, Kho, Tir, Mor, Sha, Meh, Aba, Aza, Day, Bah,^Esf, ***
	this.DaysToMonth[this.dkGregorian] = new Array(0, 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365);
													// Jan,^Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec, ***
	this.DaysToMonth[this.dkHijri] = new Array(0, 1, 30, 59, 89, 118, 148, 177, 207, 236, 266, 295, 325, 355);
												// Moh, Saf,^Ra1, Ra2, Ja1, Ja2, Raj, Sha, Ram, Shv, Zig,^Zih, ***
												
	this.MonthNames[this.dkSolar] = new Array('', 'فروردين', 'ارديبهشت', 'خرداد', 'تير', 'مرداد', 'شهريور', 'مهر', 'آبان', 'آذر', 'دي', 'بهمن', 'اسفند');
	this.MonthNames[this.dkGregorian] = new Array('', 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
	this.MonthNames[this.dkHijri] = new Array('', 'محرم', 'صفر', 'ربيع الاول', 'ربيع الثاني', 'جمادي الاولي', 'جمادى‌الثانية', 'رجب', 'شعبان', 'رمضان', 'شوال', 'ذي القعدة', 'ذي الحجة');

	//('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'),
	this.DayNames[this.dkSolar] = new Array('يکشنبه', 'دوشنبه', 'سه شنبه', 'چهارشنبه', 'پنج شنبه', 'جمعه', 'شنبه');
	this.DayNames[this.dkGregorian] = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
	this.DayNames[this.dkHijri] = new Array('الأحد', 'الاثنين', 'الثلاثاء', 'الأربعاء', 'الخميس', 'الجمعة', 'السبت');

	this.TodayNames[this.dkSolar] = new Array('امروز', 'فردا');
	this.TodayNames[this.dkGregorian] = new Array('Today', 'Tomorrow');
	this.TodayNames[this.dkHijri] = new Array('اليوم', 'غدا');
}

TDate.prototype.IsLeapYear = function(DateKind, Year)
{
	if (DateKind == this.dkSolar) 
		return ((((Year + 38) * 31) % 128) <= 30);
	else
		if (DateKind == this.dkGregorian) 
			return (((Year % 4) == 0) && (((Year % 100) != 0) || ((Year % 400) == 0)));
		else
			return false;	// for dkHijri
}

TDate.prototype.DaysOfMonth = function(DateKind, Year, Month)
{
	var Result;
	if ((Year != 0) && ((Month <= 12) && (Month >= 1))) 
	{
		Result = this.DaysOfMonths[DateKind][Month];
		if ((Month == this.LeapMonth[DateKind]) && this.IsLeapYear(DateKind, Year)) Result++;
	}
	else
		Result = 0;
	return Result;
}

TDate.prototype.IsDateValid = function(DateKind, Year, Month, Day)
{
	var Result;
	Result = ((Year != 0) && (Month >= 1) && (Month <= 12) && (Day >= 1));
	
	if (DateKind != this.dkHijri)
		Result = Result && (Day <= (this.DaysOfMonth(DateKind, Year, Month)));
	
	return Result;
}

TDate.prototype.DaysToDate = function(DateKind, Year, Month, Day)
{
	var Result;
	if (this.IsDateValid(DateKind, Year, Month, Day))
	{
		Result = this.DaysToMonth[DateKind][Month] + Day;
		if ((Month > this.LeapMonth[DateKind]) && this.IsLeapYear(DateKind, Year)) Result++;
	}
	else
		Result = 0;
	return Result;
}

TDate.prototype.DateOfDay = function(DateKind, Days, Year, Month, Day)
{
	var LeapDay = 0;
	Month.value = 0;
	Day.value = 0;
	for (var m = 2; m <= 13; m++) 
	{
		if ((m > this.LeapMonth[DateKind]) && (this.IsLeapYear(DateKind, Year))) LeapDay = 1;
		if (Days <= (this.DaysToMonth[DateKind][m] + LeapDay))
		{
			Month.value = m - 1;
			if (Month.value <= this.LeapMonth[DateKind]) LeapDay = 0;
			Day.value = Days - (this.DaysToMonth[DateKind][Month.value] + LeapDay);
			break;
		}
	}
	return this.IsDateValid(DateKind, Year, Month.value, Day.value);
}

TDate.prototype.GregorianToSolar = function(Year, Month, Day)
{
	var	LeapDay, Days, PrevGregorianLeap, Result;
	if (this.IsDateValid(this.dkGregorian, Year.value, Month.value, Day.value))
	{
		PrevGregorianLeap = this.IsLeapYear(this.dkGregorian, Year.value - 1);
		Days = this.DaysToDate(this.dkGregorian, Year.value, Month.value, Day.value);
		Year.value -= 622;
		if (this.IsLeapYear(this.dkSolar, Year.value)) LeapDay = 1
		else LeapDay = 0;
		if (PrevGregorianLeap && (LeapDay == 1)) Days += 287
		else Days += 286;
		if (Days > (365 + LeapDay))
		{
			Year.value++;
			Days -= (365 + LeapDay);
		}
		Result = this.DateOfDay(this.dkSolar, Days, Year.value, Month, Day);
	}
	else Result = false;
	return Result;
}

TDate.prototype.SolarToGregorian = function(Year, Month, Day)
{
	var LeapDay, Days, PrevSolarLeap, Result;
	if (this.IsDateValid(this.dkSolar, Year.value, Month.value, Day.value))
	{
    	PrevSolarLeap = this.IsLeapYear(this.dkSolar, Year.value - 1);
    	Days = this.DaysToDate(this.dkSolar, Year.value, Month.value, Day.value);
	    Year.value += 621;
    	if (this.IsLeapYear(this.dkGregorian, Year.value)) LeapDay = 1
	    else LeapDay = 0;
	    if (PrevSolarLeap && (LeapDay == 1)) Days += 80
	    else Days += 79;
	    if (Days > (365 + LeapDay))
	    {
			Year.value++;
			Days -= (365 + LeapDay);
		}
		Result = this.DateOfDay(this.dkGregorian, Days, Year.value, Month, Day);
	}
	else Result = false;
	return Result;
}

TDate.prototype.GregorianToHijri = function(Year, Month, Day)
{
	var tmpYear, tmpDay, Result;
	if (this.IsDateValid(this.dkGregorian, Year.value, Month.value, Day.value))
	{
    	if (Year.value <= 1582)
		{
			tmpYear = Year.value - 700;
			tmpYear = (tmpYear * 1.030711) + 80.8442;
			tmpDay = (Frac(tmpYear) * 354) + this.DaysToDate(this.dkGregorian, Year.value, Month.value, Day.value);
			Year.value = Math.floor(tmpYear);
		}
		else
		{
			tmpYear = Year.value - 1600;
			tmpYear = (tmpYear * 1.030690) + 1008.45547;
			tmpDay = (Frac(tmpYear) * 354) + this.DaysToDate(this.dkGregorian, Year.value, Month.value, Day.value);
			Year.value = Math.floor(tmpYear);
		}
		
		if (tmpDay > 354)
		{
			Year.value++;
			Day.value = Math.round(tmpDay);
			Day.value -= 354;
		}
		else
			Day.value = Math.floor(tmpDay);

		Result = this.DateOfDay(this.dkHijri, Day.value, Year.value, Month, Day);
	}
	else
		Result = false;
	return Result;		
}

TDate.prototype.getHijri = function(Year, Month, Day)
{
    // Retrieve the local time.
	var Result = "";
	var Y = new Integer(Year);
	var M = new Integer(Month);
	var D = new Integer(Day);
	
	if (this.GregorianToHijri(Y, M, D))
		Result = D.value + " " + this.MonthNames[this.dkHijri][M.value] + " " + Y.value;

	return Result;
}

TDate.prototype.getDate = function(Year, Month, Day, dateKind)
{
	var Result = "";
	var Y = new Integer(Year);
	var M = new Integer(Month);
	var D = new Integer(Day);
	
	var r = false;
	switch (dateKind)
	{	
		case this.dkSolar: r = this.GregorianToSolar(Y, M, D); break;
		case this.dkHijri: r = this.GregorianToHijri(Y, M, D); break;
		default: r = true;	
	}
	
	if (r)
		Result = D.value + " " + this.MonthNames[dateKind][M.value] + " " + Y.value;

	return Result;
}

TDate.prototype.getMonthAndYear = function(Year, Month, Day, dateKind)
{
	var Result = "";
	var Y = new Integer(Year);
	var M = new Integer(Month);
	var D = new Integer(Day);
	
	var r = false;
	switch (dateKind)
	{	
		case this.dkSolar: r = this.GregorianToSolar(Y, M, D); break;
		case this.dkHijri: r = this.GregorianToHijri(Y, M, D); break;
		default: r = true;	
	}
	
	if (r)
		Result = this.MonthNames[dateKind][M.value] + " " + Y.value;

	return Result;
}

TDate.prototype.getFirstDayOfMonth = function(Year, Month, Day, dateKind)
{
	var Result = new Date(Year, Month-1, Day, 0, 0, 0, 0);
	var Y = new Integer(Year);
	var M = new Integer(Month);
	var D = new Integer(Day);
	
	var r = false;
	switch (dateKind)
	{	
		case this.dkSolar: r = this.GregorianToSolar(Y, M, D); break;
		case this.dkHijri: r = this.GregorianToHijri(Y, M, D); break;
		default: r = true;	
	}

	Result.setDate(Result.getDate()- D.value +1);

	return Result;
}

TDate.prototype.getLastDayOfMonth = function(Year, Month, Day, dateKind)
{
	var Result = new Date(Year, Month-1, Day, 0, 0, 0, 0);
	var Y = new Integer(Year);
	var M = new Integer(Month);
	var D = new Integer(Day);
	
	var r = false;
	switch (dateKind)
	{	
		case this.dkSolar: r = this.GregorianToSolar(Y, M, D); break;
		case this.dkHijri: r = this.GregorianToHijri(Y, M, D); break;
		default: r = true;	
	}

	Result.setDate(Result.getDate() + (this.DaysOfMonth(dateKind, Y.value, M.value) - D.value +1));

	return Result;
}

TDate.prototype.getDayName = function(Day, dateKind)
{
	return (this.DayNames[dateKind][Day]);
}

TDate.prototype.getMonthName = function(Month, dateKind)
{
	return (this.MonthNames[dateKind][Month]);
}

TDate.prototype.getTodayName = function(AddDay, dateKind)
{
	return (this.TodayNames[dateKind][AddDay]);
}

//------------------------ Date Object -----------------------------------

var myDate = new TDate();
