﻿// Rafed Pray Times Gadget!
// Hossein Taghi-Zadeh
// Best thanks to "Hamid Zarrabi-Zadeh" 
// This module based on "Pray Times! firefox add-ons" module
// Licensed under GPL

function AzanMisc() 
{
	// Events
	this.None = 0;
	this.ResetData = 1;
	this.StopSound = 2;
	
	this.Stopped = true;
	
	this.activeTabIndex = 0;
	this.tabs = new Array('General', 'Display', 'Calculations', 'Misc', 'About');
	this.theZekrs = new Array('يا ذالجلال والاكرام', 'يا قاضى‌الحاجات', 'يا ارحم‌الراحمين', 'ياحى ياقيوم', 'لااله الاالله الملك الحق المبين', 'اللهم صل على محمد وآل محمد وعجل فرجهم', 'يا رب‌العالمين');
	
	this.player = new ActiveXObject("WMPlayer.OCX.7");
}

//--------------------------- Utils -----------------------------

// check array membership
AzanMisc.prototype.isMember = function(anArray, aValue) 
{
	var temp = '|' + anArray.join('|') + '|';
	if (temp.indexOf('|' + aValue + '|') == -1) 
		return false;
	else 
		return true;
}  

//----------------------- DOM Functions ------------------------
 
// remove all childs of a DOM node
AzanMisc.prototype.removeChildrenOfNode = function(node)
{
	if (node == undefined || node == null)
		return;

	while (node.firstChild)
		node.removeChild(node.firstChild);
}

// remove a DOM node
AzanMisc.prototype.removeNode = function(node)
{
	if (node == undefined || node == null || !node.parentNode)
	{
		return null;		
	}
	return node.parentNode.removeChild(node);
}

// retruen first value of a tag in doc
AzanMisc.prototype.getTagValue = function(doc, tagName)
{
	var item = doc.getElementsByTagName(tagName);
	return (item && item.length > 0 && item[0].firstChild) ? item[0].firstChild.nodeValue : '';
}

//---------------------- Date & Time Functions -----------------------

// return month abbreviated name
AzanMisc.prototype.monthName = function(month)
{
	var monthName = new Array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 
					'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	return monthName[month];
}

// return month full name
AzanMisc.prototype.monthFullName = function(month)
{
	var monthName = new Array('January', 'February', 'March', 'April', 'May', 'June', 
					'July', 'August', 'September', 'October', 'November', 'December');
	return monthName[month];
}

// convert 24h times to 12h format
AzanMisc.prototype.floatToTime12 = function(time)
{
	if (time.indexOf(':') == -1)
		return ('NA');
	var times = time.split(':');
	var hours = times[0];
	var minutes = times[1];
	var suffix = hours >= 12 ? 'pm' : 'am';
	hours = (hours -1)% 12+ 1;
	if (hours <10) {hours = '0'+ hours}
	return hours+ ':'+ minutes+ ' '+ suffix;
}

// add a leading 0 if necessary
AzanMisc.prototype.twoDigitsFormat = function(num)
{
	return (num <10) ? '0'+ num : num;
}

// compute number of minutes in a float time 
AzanMisc.prototype.timeMinutes = function(time)
{
	return Math.floor(time* 60);
}

// return next day of a date
AzanMisc.prototype.nextDay = function(date)
{
	var nextDay = new Date(date);
	nextDay.setDate(date.getDate()+ 1);
	return nextDay;
}

//---------------------- PrayTime Functions -----------------------

// load preferences for prayTime object
AzanMisc.prototype.loadPrayTimePrefs = function()
{
	prayTime.setCalcMethod(azanPrefs.getIntPref('calcMethod'));
	prayTime.setAsrMethod(azanPrefs.getAsrJuristic());
	prayTime.setDhuhrMinutes(1* azanPrefs.getStrPref('dhuhrMinutes'));
	prayTime.setHighLatsMethod(azanPrefs.getIntPref('adjustHighLats'));

	prayTime.setCustomParams(new Array(
		1* azanPrefs.getStrPref('fajrAngle'),
		1* azanPrefs.getIntPref('maghribSelector'),
		1* azanPrefs.getStrPref('maghribAngleMinutes'),
		1* azanPrefs.getIntPref('ishaSelector'),
		1* azanPrefs.getStrPref('ishaAngleMinutes')
	));
}

// return current time zone 
AzanMisc.prototype.getCurrentTimeZone = function(date) 
{
	var currentTimeZone = 1* azanPrefs.getStrPref('timeZone');
	if (azanPrefs.getBoolPref('timeZoneAuto'))
		currentTimeZone = prayTime.getTimeZone(date);
	return currentTimeZone;
}

//---------------------- Play Sound (wmplayer activex) -----------------------

// play a sound file
AzanMisc.prototype.playFile = function(fileName, volume)
{
	volume = volume != null ? (volume+ 1)* 10 : 100;

	if (!fileExists(fileName))
		fileName = gadgetPath + "\\sound\\moazen-zadeh.mp3";

	try
	{
		if (this.player)
		{
			if (!this.Stopped)
				this.player.controls.play();
			this.player.settings.volume = volume;
			this.player.URL = fileName;
			this.Stopped = false;
			this.player.controls.play();
		}
	}
	catch(ex){}
}

// play a sound file
AzanMisc.prototype.playAlert = function()
{
	var volume = azanPrefs.getIntPref('soundVolume');
	volume = volume != null ? (volume+ 1)* 10 : 100;
	
	var fileName = azanPrefs.getStrPref('preSoundFileName');
	if (!fileExists(fileName))
		fileName = gadgetPath + "\\sound\\alert.mp3";
		
	try
	{
		if (this.player)
		{
			if (!this.Stopped)
				this.player.controls.play();
			this.player.settings.volume = volume;
			this.player.URL = fileName;
			this.player.controls.play();
			this.Stopped = false;
		}
	}
	catch(ex){}
}

// stop sound 
AzanMisc.prototype.stopSound = function()
{
	try
	{
		if (this.player)
		{
			this.player.controls.stop();
			this.Stopped = true;
		}
	}
	catch(ex){}
}

// stop sound pressed
AzanMisc.prototype.stopSoundPressed = function()
{
	azanMisc.triggerEvent(azanMisc.StopSound);
	azanPrefs.setBoolPref('notificationShowed', false);
	azanPrefs.setBoolPref('azanPlaying', false);	
	azanMisc.stopSound();
}


// play sound pressed
AzanMisc.prototype.playSoundPressed = function()
{
	azanMisc.playFile(azanPrefs.getStrPref('soundFileName'), azanPrefs.getIntPref('soundVolume'));	
}

//------------------------- Events -----------------------

// trigger an event
AzanMisc.prototype.triggerEvent = function(eventID)
{
	azanPrefs.setIntPref('currentEvent', eventID);
	azanMisc.resetEvent();
}

// reset event
AzanMisc.prototype.resetEvent = function()
{
	setTimeout("azanPrefs.setIntPref('currentEvent', 0);", 1100);
}

// refresh azan data
AzanMisc.prototype.resetAzanData = function()
{
	azanMisc.triggerEvent(azanMisc.ResetData);
}

//---------------------- Other Functions -----------------------

AzanMisc.prototype.getWeekDaysZekr = function(dayOfWeek)
{
	return(this.theZekrs[dayOfWeek]);
}

AzanMisc.prototype.showTab = function(index)
{
  	this.resetTab();
	this.activeTabIndex = index;
	
	var sName = this.tabs[this.activeTabIndex];
	$('tab' + sName).className = 'selected';
	$(sName + '_content').style.display = '';
}

AzanMisc.prototype.resetTab = function()
{
	var sName = this.tabs[this.activeTabIndex];
	$('tab' + sName).className = '';
	$(sName + '_content').style.display = 'none';
}

AzanMisc.prototype.getTabIndex = function()
{
	return (this.activeTabIndex);
}

AzanMisc.prototype.setItemIndex = function(ComboBox, sValue)
{
	for(var i=0; i<ComboBox.options.length; i++)
	{
		if(ComboBox.options[i].value == sValue)
		{
			ComboBox.selectedIndex = i;
			return;
		}
	}
}

AzanMisc.prototype.getRadioValue = function(radioName)
{
	var list = document.getElementsByName(radioName);
	
	for(var i=0; i<list.length; i++)
		if (list[i].checked)
			return(list[i].value);
}

AzanMisc.prototype.setRadioValue = function(radioName, iValue)
{
	var list = document.getElementsByName(radioName);
	
	for(var i=0; i<list.length; i++)
		if (list[i].value == iValue)
		{
			list[i].checked = true;
			return;
		}
}

AzanMisc.prototype.addTableHeader = function(table)
{
	if (table == undefined || table == null)
		return;

	var row = document.createElement('tr');

	var head1 = document.createElement('th');
	head1.innerText = 'Address';
	var head2 = document.createElement('th');
	head2.innerText = 'Latitude';
	var head3 = document.createElement('th');
	head3.innerText = 'Longitude';

	var cell1 = document.createElement('td');
	cell1.appendChild(head1);
	var cell2 = document.createElement('td');
	cell2.appendChild(head2);
	var cell3 = document.createElement('td');
	cell3.appendChild(head3);
    
	row.appendChild(cell1);
	row.appendChild(cell2);
	row.appendChild(cell3);

	table.appendChild(row);
}

AzanMisc.prototype.refreshZekr = function(now)
{
	var dayOfWeek = now.getDay();

	$("tooltip-theTicker").innerHTML = '<span class="jstop">'+this.theZekrs[dayOfWeek]+'</span>';
}

//------------------------- Misc Object -----------------------

var azanMisc = new AzanMisc();

