// Rafed Pray Times Gadget!
// Hossein Taghi-Zadeh
// Best thanks to "Hamid Zarrabi-Zadeh" 
// This module based on "Pray Times! firefox add-ons" module
// Licensed under GPL

function AzanOptions() 
{

	//this.mapRequest = new ActiveXObject("Microsoft.XMLHTTP");
	this.mapRequest = new XMLHttpRequest;
	this.mapRequestRunning = false;

	this.mapLocation = '';
	this.mapLatitude = 0;
	this.mapLongitude = 0;

	this.mapDataIsReady = false;

	this.num = 7;
	this.name = new Array('Fajr', 'Sunrise', 'Dhuhr', 'Asr', 'Sunset', 'Maghrib', 'Isha');

	this.isPlaying = false;

	this.monthDist = 0;  // month indicator for monthly timetable
}


//---------------------- Read Google Map Data -----------------------

// extract map data from the xml doc 
AzanOptions.prototype.extractGoogleMapData = function(doc) 
{
	var myLocation = azanMisc.getTagValue(doc, 'address');
	if (myLocation == '')
	{
		myLocation = 'Address not found!';
		azanOptions.setLocationButton(false);
	}
	else
	{
		azanOptions.setLocationButton(true);
		var azanLongLat = azanMisc.getTagValue(doc, 'coordinates').split(',');
		azanOptions.mapLongitude = azanLongLat[0];
		azanOptions.mapLatitude = azanLongLat[1];
	}
	azanOptions.mapLocation = myLocation;
}

// handler for the XMLHttpRequest
AzanOptions.prototype.processGoogleMapRequest = function() 
{
	if (azanOptions.mapRequest.readyState == 4) 
	{
		azanOptions.mapRequestRunning = false;
		if(azanOptions.mapRequest.status == 200)
		{
			var doc = azanOptions.mapRequest.responseXML;
			//alert(azanOptions.mapRequest.responseText);
			azanOptions.extractGoogleMapData(doc);
			azanOptions.displayLocation(azanOptions.mapLocation);
			if (azanOptions.mapLocation == 'Address not found!' && $('search-engine').value == 'auto')
				azanOptions.readYahooMapData();
		}
		else
			azanOptions.displayLocation('Error reading map data!');
	}
}

// create the map url 
AzanOptions.prototype.GoogleMapURL = function()
{
	var key = 'ABQIAAAAE81_iMuskdjZKzjccoGbjxRlYeoEVuxJX_hBmeWhnDUCnhRAYhS9fgoqaFUYAK3qHNUit5bepB8LFQ';
	var item = $('city-text-search');
	var myLocation = item ? item.value : '';
	var URL = 'http://maps.google.com/maps/geo';
	URL = URL + '?q='+ myLocation.replace(/ /g, '+');  //encodeURI(myLocation);
	URL = URL + '&output=xml&key='+ key;

	return URL; 
}

// reading map data using XMLHttpRequest
AzanOptions.prototype.readGoogleMapData = function() 
{
	azanOptions.displayLocation('&nbsp; <img src="../images/loading.gif"> &nbsp; Loading Address...');
	azanOptions.mapRequestRunning = true;

	azanOptions.mapRequest.open('GET', azanOptions.GoogleMapURL(), true);
	azanOptions.mapRequest.onreadystatechange = azanOptions.processGoogleMapRequest;
	azanOptions.mapRequest.send(null); 	
}


//---------------------- Read Yahoo Map Data -----------------------

// extract map data from the doc 
AzanOptions.prototype.extractYahooMapData = function(doc) 
{
	var myLocation = '';
	if (!doc.getElementsByTagName('Result'))
	{
		myLocation = 'Address not found!';
		azanOptions.setLocationButton(false);
	}
	else
	{
		azanOptions.setLocationButton(true);
		var city = azanMisc.getTagValue(doc, 'City');
		var state = azanMisc.getTagValue(doc, 'State');
		var country = azanMisc.getTagValue(doc, 'Country');
		var zip = azanMisc.getTagValue(doc, 'Zip');
		if (zip != '') myLocation += zip+ ', ';
		if (city != '') myLocation += city+ ', ';
		myLocation += (state != '') ? state : country;
		if (state != '' && country != '') myLocation += ', '+ country;

		azanOptions.mapLongitude = azanMisc.getTagValue(doc, 'Longitude');
		azanOptions.mapLatitude = azanMisc.getTagValue(doc, 'Latitude');
	}
	azanOptions.mapLocation = myLocation;
}

// handler for the XMLHttpRequest
AzanOptions.prototype.processYahooMapRequest = function() 
{
	if (azanOptions.mapRequest.readyState == 4) 
	{
		azanOptions.mapRequestRunning = false;
		if(azanOptions.mapRequest.status == 200)
		{
			var doc = azanOptions.mapRequest.responseXML;
			azanOptions.extractYahooMapData(doc);
			azanOptions.displayLocation(azanOptions.mapLocation);
		}
		else
			azanOptions.displayLocation('Error reading map data!');
	}
}

// create the map url 
AzanOptions.prototype.YahooMapURL = function()
{
	//http://api.local.yahoo.com/MapsService/V1/geocode?appid=luJ0OVPV34ESk2EYbsIzGggXxo6BFFS4QoPxvwSB3_VAG_qcpJ9t1SxRyoI4CAy31hkSLg--&location=Waterloo
	var key = 'luJ0OVPV34ESk2EYbsIzGggXxo6BFFS4QoPxvwSB3_VAG_qcpJ9t1SxRyoI4CAy31hkSLg--';
	var item = $('city-text-search');
	var myLocation = item.value; 
	var URL = 'http://api.local.yahoo.com/MapsService/V1/geocode';
	URL = URL + '?appid='+ key;
	URL = URL + '&location='+ encodeURI(myLocation);

	return URL; 
}

// reading map data using XMLHttpRequest
AzanOptions.prototype.readYahooMapData = function() 
{
	azanOptions.displayLocation('&nbsp; <img src="../images/loading.gif"> &nbsp; Loading Address...');
	azanOptions.mapRequestRunning = true;

	azanOptions.mapRequest.open('GET', azanOptions.YahooMapURL(), true);
	azanOptions.mapRequest.onreadystatechange = azanOptions.processYahooMapRequest;
	azanOptions.mapRequest.send(null); 
}

//---------------------- Set Location -----------------------

// reading map data 
AzanOptions.prototype.readMapData = function() 
{
	azanOptions.setLocationButton(false);
	var searchStr = $('city-text-search').value;
	if (searchStr == '')
		return;

	var engine = $('search-engine').value;
	if (engine == 'google' || engine == 'auto')
		azanOptions.readGoogleMapData();
	else
		azanOptions.readYahooMapData();

}

// show a text in location tree
AzanOptions.prototype.displayLocation = function(myLocation)
{
	//alert(myLocation);
	var results = $('azan-locations-results');

	var content = document.createElement('tbody');
	var row = document.createElement('tr');
	var cell1 = document.createElement('td');
	cell1.innerHTML = myLocation;
	var cell2 = document.createElement('td');
	cell2.innerText = (azanOptions.mapDataIsReady ? azanOptions.mapLatitude : '');
	var cell3 = document.createElement('td');
	cell3.innerText = (azanOptions.mapDataIsReady ? azanOptions.mapLongitude : '');
    
	row.appendChild(cell1);
	row.appendChild(cell2);
	row.appendChild(cell3);

	azanMisc.removeChildrenOfNode(results);
	azanMisc.addTableHeader(results);
	content.appendChild(row);
	results.appendChild(content);
}

// show a text in location tree
AzanOptions.prototype.initLocation = function()
{
	//alert(myLocation);
	var results = $('azan-locations-results');

	var content = document.createElement('tbody');
	var row = document.createElement('tr');
	var cell1 = document.createElement('td');
	cell1.innerText = azanPrefs.getStrPref('location');
	var cell2 = document.createElement('td');
	cell2.innerText = azanPrefs.getStrPref('latitude');
	var cell3 = document.createElement('td');
	cell3.innerText = azanPrefs.getStrPref('longitude');
    
	row.appendChild(cell1);
	row.appendChild(cell2);
	row.appendChild(cell3);

	azanMisc.removeChildrenOfNode(results);
	azanMisc.addTableHeader(content);
	content.appendChild(row);
	results.appendChild(content);
}

//set the location button
AzanOptions.prototype.setLocationButton = function(which)
{
	azanOptions.mapDataIsReady = which;
}

//set the location infrmation
AzanOptions.prototype.setLocation = function()
{
	if (!azanOptions.mapDataIsReady)
		return;

	azanPrefs.setStrPref('location', azanOptions.mapLocation);
	azanPrefs.setStrPref('longitude', azanOptions.mapLongitude);
	azanPrefs.setStrPref('latitude', azanOptions.mapLatitude);
}

//---------------------- Options Functions -----------------------

// initialize options window
AzanOptions.prototype.initOptionsDialog = function()
{
	$('city-text-search').value = azanPrefs.getStrPref('location');

	azanOptions.initTimeZoneList();
	var sName = 'time-zone-group-' + (azanPrefs.getBoolPref('timeZoneAuto') ? '1' : '0');
	$(sName).checked = true;
	azanOptions.toggleTimeZoneAuto();

	azanOptions.initLocation();
	
	azanMisc.showTab(azanPrefs.getIntPref('activeTabIndex'));

	azanMisc.setRadioValue('display-mode-group', azanPrefs.getIntPref('azanDisplayMode'));
	azanMisc.setItemIndex($('start-count-down'), azanPrefs.getIntPref("startCountDown"));

	$('removeLeadingZeroHours').checked = !azanPrefs.getBoolPref('removeLeadingZeroHours');
	$('removeSecondsIfHours').checked = !azanPrefs.getBoolPref('removeSecondsIfHours');

	$('playSound').checked = !azanPrefs.getBoolPref('playSound');
	$('showPreNotification').checked = azanPrefs.getBoolPref('showPreNotification');
	azanMisc.setItemIndex($('clockFormat'), ((azanPrefs.getIntPref("clockFormat") == 0)? 1: 0));
	azanMisc.setItemIndex($('preMins'), azanPrefs.getIntPref("preNotificationMinutes"));

	var snd = azanPrefs.getStrPref('soundFileName');
	if (snd == '') snd = 'default';
	$('sound-url').value = snd;
	$('curr-azan').innerText = snd;

	var snd = azanPrefs.getStrPref('preSoundFileName');
	if (snd == '') snd = 'default';
	$('pre-sound-url').value = snd;
	$('curr-pre-azan').innerText = snd;

	azanOptions.loadFlags();

	azanMisc.loadPrayTimePrefs();
	azanMisc.setItemIndex($('calc-method'), azanPrefs.getIntPref("calcMethod"));
	azanOptions.loadMethodDefaults(prayTime.methodParams[azanPrefs.getIntPref('calcMethod')]);

	$('dhuhrMinutes').value = 1* azanPrefs.getStrPref('dhuhrMinutes');
	azanMisc.setItemIndex($('asrJuristic'), azanPrefs.getIntPref("asrJuristic"));
	azanMisc.setItemIndex($('adjustHighLats'), azanPrefs.getIntPref("adjustHighLats"));
	
	azanMisc.setItemIndex($('language'), azanPrefs.getIntPref("language"));
	azanMisc.setItemIndex($('dateKind'), azanPrefs.getIntPref("dateKind"));
	azanMisc.setItemIndex($('HijriAdjust'), azanPrefs.getIntPref("HijriAdjust"));
}

// option window's apply and close
AzanOptions.prototype.saveOptionsDialog = function()
{
	azanPrefs.setIntPref("activeTabIndex", azanMisc.getTabIndex());

	azanPrefs.setBoolPref("timeZoneAuto", $('time-zone-group-1').checked);
	azanPrefs.setStrPref("timeZone", $('time-zone-list').value);

	this.setLocation();

	azanPrefs.setIntPref("clockFormat", (($('clockFormat').value == 0)? 1: 0));
	azanPrefs.setIntPref('azanDisplayMode', azanMisc.getRadioValue('display-mode-group'));
	azanPrefs.setIntPref('startCountDown', $('start-count-down').value);
	azanPrefs.setBoolPref('playSound', !$('playSound').checked);
	azanPrefs.setBoolPref('showPreNotification', $('showPreNotification').checked);
	azanPrefs.setIntPref ('preNotificationMinutes', parseInt($('preMins').value));
	if ($('change-azan').checked)
		azanPrefs.setStrPref ('soundFileName', $('sound-url').value);

	if ($('change-pre-azan').checked)
		azanPrefs.setStrPref ('preSoundFileName', $('pre-sound-url').value);

	azanPrefs.setBoolPref('removeLeadingZeroHours', !$('removeLeadingZeroHours').checked);
	azanPrefs.setBoolPref('removeSecondsIfHours', !$('removeSecondsIfHours').checked);

	azanPrefs.setIntPref("dateKind", $('dateKind').value);
	azanPrefs.setIntPref("HijriAdjust", $('HijriAdjust').value);	
	azanPrefs.setIntPref("language", $('language').value);	

	azanOptions.saveFlags();
	azanOptions.saveMethodParams();

	azanMisc.resetAzanData();

	azanOptions.dirty(false);
}

// initialize time zone list in options window
AzanOptions.prototype.initTimeZoneList = function()
{
	var halfHours = Array(-3,3,4,5,6,9);
	var timeZoneList = $('time-zone-list');

	var currentTimeZone = azanMisc.getCurrentTimeZone(new Date());
	var selected = -1;
	
	var j = 0;
	timeZoneList.options.length = 0;
	for (var i=-24 ; i<=26 ; i++)
	{
		var hour = Math.floor((i<0 ? i+1 : i)/2);
		var minutes = (i%2 == 0) ? '00' : '30';
		var timeZoneText = 'GMT '+ (i<0 ? '-' : '+')+ azanMisc.twoDigitsFormat(Math.abs(hour))+ ':'+ minutes;
		if (minutes != '00' && !azanMisc.isMember(halfHours, hour))
			continue;
		
        timeZoneList.options[j] = new Option(timeZoneText, i/2);
		if (currentTimeZone == i/2) selected = j;
		j++;
	}
	timeZoneList.selectedIndex = (selected != -1) ? selected : 0;	
}

// turn time-zone-list on and off
AzanOptions.prototype.toggleTimeZoneAuto = function()
{
	var disabled = $('time-zone-group-1').checked;
	$('time-zone-list').disabled = disabled;
}

// toggle show tooltip contents 
AzanOptions.prototype.toggleShowTooltip = function()
{
	var disabled = !$('showTooltip').checked;
	$('showTooltipTimes').disabled = disabled;
	$('showTooltipTimeLeft').disabled = disabled;
}


// enable and disable apply buttom
AzanOptions.prototype.dirty = function(mode)
{
}

// import defaults for each calculation method
AzanOptions.prototype.importMethodDefaults = function()
{
	var method = $('calc-method').value;
	azanOptions.loadMethodDefaults(prayTime.methodParams[method]);
}

// load default values of calculation metgod parameters
AzanOptions.prototype.loadMethodDefaults = function(defaults)
{
	$('fajrAngle').value = defaults[0];
	azanMisc.setRadioValue('maghribSelector', defaults[1]);
	$('maghribAngleMinutes').value = defaults[2];
	azanMisc.setRadioValue('ishaSelector', defaults[3]);
	$('ishaAngleMinutes').value = defaults[4];
}

// save parameters for calculation method
AzanOptions.prototype.saveMethodParams = function()
{
	azanPrefs.setIntPref("calcMethod", $('calc-method').value);

	azanPrefs.setStrPref('fajrAngle', $('fajrAngle').value);
	azanPrefs.setIntPref('maghribSelector', azanMisc.getRadioValue('maghribSelector'));
	azanPrefs.setStrPref('maghribAngleMinutes', $('maghribAngleMinutes').value);
	azanPrefs.setIntPref('ishaSelector', azanMisc.getRadioValue('ishaSelector'));
	azanPrefs.setStrPref('ishaAngleMinutes', $('ishaAngleMinutes').value);

	azanPrefs.setStrPref('dhuhrMinutes', $('dhuhrMinutes').value);
	azanPrefs.setIntPref("asrJuristic", $('asrJuristic').value);
	azanPrefs.setIntPref('adjustHighLats', $('adjustHighLats').value);
}

// set calculation method to custom
AzanOptions.prototype.setCustom = function()
{
	$('calc-method').value = 6; // custom setting
	azanOptions.dirty();
}

//---------------------- Azan Flags -----------------------

// apply azan and play flags into options window
AzanOptions.prototype.loadFlags = function()
{
	var showTimes = $('show-azan-times-list');
	azanMisc.removeChildrenOfNode(showTimes);

	var azanFlags = azanPrefs.getStrPref('azanFlags');

	for (var i=0 ; i<this.num ; i++)
	{
		var c1 = document.createElement('input');
		var c2 = document.createTextNode(this.name[i]+' ');
		c1.type = 'checkbox';
		if (azanFlags.charAt(i) == 'c')
		{
			c1.defaultChecked = true;
			c1.checked = true;
		}
		showTimes.appendChild(c1);
		showTimes.appendChild(c2);
	}
}

// update azan flags
AzanOptions.prototype.saveFlags = function()
{
	var azanFlags = '';
	var showTimes = $('show-azan-times-list');
	
	for (var i=0 ; i<showTimes.childNodes.length ; i++)
		if (showTimes.childNodes[i].type == 'checkbox')
			azanFlags += ((showTimes.childNodes[i].checked) ? 'c' : 'u');

	azanPrefs.setStrPref('azanFlags', azanFlags);
}

//---------------------- Monthly Timetable -----------------------

// create monthly timetable
AzanOptions.prototype.fillTimeTable = function()
{
	var sPath = gadgetPath + "\\monthly\\vars.js";
	/*if (fileExists(sPath)) deleteFile(sPath);*/
	
	var sContent = Array("", "", "");
	
	sContent[0] = "var lat = '"+azanPrefs.getStrPref('latitude')+"';";
	sContent[1] = "var lng = '"+azanPrefs.getStrPref('longitude')+"';";

	var now = new Date();
	sContent[2] = "var timeZone = '"+azanMisc.getCurrentTimeZone(now)+"';";

	sContent[3] = "prayTime.setCalcMethod("+azanPrefs.getIntPref('calcMethod')+");";
	sContent[4] = "prayTime.setAsrMethod("+azanPrefs.getAsrJuristic()+");";
	sContent[5] = "prayTime.setDhuhrMinutes("+ (1* azanPrefs.getStrPref('dhuhrMinutes'))+");";
	sContent[6] = "prayTime.setHighLatsMethod("+azanPrefs.getIntPref('adjustHighLats')+");";

	sContent[7] = "prayTime.setCustomParams(new Array(";
	sContent[8] = (1* azanPrefs.getStrPref('fajrAngle'))+",";
	sContent[9] = (1* azanPrefs.getIntPref('maghribSelector'))+",";
	sContent[10] = (1* azanPrefs.getStrPref('maghribAngleMinutes'))+",";
	sContent[11] = (1* azanPrefs.getIntPref('ishaSelector'))+",";
	sContent[12] = (1* azanPrefs.getStrPref('ishaAngleMinutes'))+"));";
	sContent[13] = "var dateKind = " + azanPrefs.getIntPref('dateKind')+";";

	createFile(sPath, sContent);
	shellExec(gadgetPath + '\\monthly.htm');

/*if (azanPrefs.getIntPref('clockFormat') == 0) 
			prayTime.setTimeFormat(prayTime.Time12NS) // 12-hour format with no suffix
*/	
}

//----------------------  Sound Buttons -----------------------

// play sound  
AzanOptions.prototype.playSound = function(forTest)
{
	var soundFile = azanPrefs.getStrPref('soundFileName'); 
	if (forTest)
		if (fileExists($('sound-url').value)) soundFile = $('sound-url').value;

	if (!fileExists(soundFile))
		soundFile = gadgetPath + "\\sound\\moazen-zadeh.mp3";

	var volume = parseInt($('soundVolume').value);
	this.isPlaying = true;
	azanMisc.playFile(soundFile, volume);
}

// stop sound  
AzanOptions.prototype.stopSound = function()
{
	this.isPlaying = false;
	azanMisc.stopSoundPressed();
}

// reset sound  
AzanOptions.prototype.resetSound = function()
{
	if (this.isPlaying)
		this.playSound();
}

//---------------------- Options Object -----------------------

var azanOptions = new AzanOptions();

System.Gadget.onSettingsClosing = function(event)
{
	if (event.closeAction == event.Action.commit) 
	{
		azanOptions.saveOptionsDialog();
		event.cancel = false;
	}
	else if (event.closeAction == event.Action.cancel) 
	{
		event.cancel = true;
	}	
}
