// Rafed Pray Times Gadget!
// Hossein Taghi-Zadeh
// Best thanks to "Hamid Zarrabi-Zadeh" 
// This module based on "Pray Times! firefox add-ons" module
// Licensed under GPL

var oFSO = null;
var oShell = null;
var gadgetPath = System.Gadget.path;

function $(elem) { return document.getElementById(elem); }
function shellExec(sPath) { System.Shell.execute(sPath); }
function echo(msg) { if (oShell == null) { oShell = new ActiveXObject("WScript.Shell"); } oShell.Popup(msg); }
function fileExists(sFile) { if (oFSO == null) { oFSO = new ActiveXObject("Scripting.FileSystemObject"); } return(oFSO.FileExists(sFile)); }
function deleteFile(sFile) { if (oFSO == null) { oFSO = new ActiveXObject("Scripting.FileSystemObject"); } oFSO.DeleteFile(sFile); }
function createFile(sFile, sContent)
{
	if (oFSO == null) { oFSO = new ActiveXObject("Scripting.FileSystemObject"); }  

	var jsFile = oFSO.OpenTextFile(sFile, 2);
	for (var i=0; i<sContent.length; i++)
		jsFile.WriteLine(sContent[i]);
	jsFile.Close();
}

function AzanPreference() 
{
	this.version = '0.98';
	this.installedVersion = '';
	this.currentEvent = 0;		// 0: none

	this.location = 'Qum, Iran';
	this.latitude = '34.65';
	this.longitude = '50.88';
	this.timeZoneAuto = false;
	this.timeZone = '3.5';

	/*this.location = 'Copenhagen, Denmark';
	this.latitude = '55.676';
	this.longitude = '12.569';
	this.timeZoneAuto = false;
	this.timeZone = '1.0';*/

	/*this.location = 'Shiraz, Iran';
	this.latitude = '29.6166667';
	this.longitude = '52.5333333';
	this.timeZoneAuto = false;
	this.timeZone = '1.0';*/

	this.language = 0;	// Arabic
	this.dateKind = 0;
	this.HijriAdjust = 0;
	this.clockFormat = 0;		//  0: 12-hour, 1: 24-hour

	this.azanFlags = 'ccccucc';
	this.azanDisplayMode = 2;	//  1: next azan, 2: countdown, 3: combination
	this.startCountDown = 60;
	this.statusBarMode = 0;		//  0: icon & text, 1: icon, 2: text

	this.showTooltip = true;
	this.showTooltipTimes = true;
	this.showTooltipTimeLeft = true;

	this.removeSecondsIfHours = false;
	this.removeLeadingZeroHours = false;

	// sound and alerts
	
	this.playSound = false
	this.soundFileName = '';
	this.preSoundFileName = '';
	this.soundVolume = 7;	// 0-9
	this.playDuration = 2;

	this.azanStarted = false;
	this.azanPlaying = false;

	this.showSliderNotification = true;
	this.notificationText = 'It is time to pray ';
	this.notificationShowed = false;

	this.showPreNotification = false;
	this.preNotificationMinutes = 1;
	this.preNotificationShowed = false;

	// calculation methods
	this.calcMethod = 0;		// 0: Ithna Ashari	7: Tehran University
	this.adjustHighLats = 0;	// 0: None	1: Mid-Night
	this.fajrAngle = '16';
	this.maghribSelector = 0;
	this.maghribAngleMinutes = '4';
	this.ishaSelector = 0;
	this.ishaAngleMinutes = '14';

	this.dhuhrMinutes = '0';
	this.asrJuristic = 0;		//	prayTime.Shafi
	this.adjustHighLatsMethod = 0;
	
	this.activeTabIndex = 0;
}

AzanPreference.prototype.getBoolPref = function(prefName, defval) 
{
	var result = this.readVar(prefName);
	if (result == '')
		result = this.getPropValue(prefName);

	return(result);
}

AzanPreference.prototype.getIntPref = function(prefName, defval)
{	
	var result = this.readVar(prefName);
	if (result == '')
		result = this.getPropValue(prefName);

	return(result);
}

AzanPreference.prototype.getStrPref = function(prefName, defval) 
{
	var result = this.readStr(prefName);
	if (result == '')
		result = this.getPropValue(prefName);

	return(result);
}

AzanPreference.prototype.setBoolPref = function(prefName, value) 
{
	System.Gadget.Settings.write(prefName, value);
}

AzanPreference.prototype.setIntPref = function(prefName, value) 
{
	System.Gadget.Settings.write(prefName, value);
}

AzanPreference.prototype.setStrPref = function(prefName, value) 
{
	System.Gadget.Settings.writeString(prefName, value);
}

AzanPreference.prototype.readVar = function (prefName) 
{
	return (System.Gadget.Settings.read(prefName));
}

AzanPreference.prototype.readStr = function (prefName) 
{
	return (System.Gadget.Settings.readString(prefName));
}

AzanPreference.prototype.getPropValue = function (prefName)
{
	var obj = this;
	for (var i in obj)
		if (prefName == i) return(obj[i]);
}

AzanPreference.prototype.getAsrJuristic = function()
{
	var aj = azanPrefs.getIntPref('asrJuristic');
	if (aj == 0)
		aj = 2
	else
		aj--;
		
	return aj;
}

var azanPrefs = new AzanPreference();
